{{ with set . "component" "ui" }}
apiVersion: apps/v1
kind: Deployment
metadata: {{ include "cgas.common.metadata" . | nindent 2 }}
spec:
  replicas: {{.Values.replicas}}
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  selector:
    matchLabels: {{ include "cgas.common.metadata-labels" . | nindent 6 }}
  template:
    metadata:
      labels: {{ include "cgas.common.metadata-labels" . | nindent 8 }}
    spec:
      containers:
        - name: ui
          image: {{.Values.uiImage | quote}}
          imagePullPolicy: {{.Values.imagePullPolicy}}
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /health
              port: 8080
              scheme: HTTP
            initialDelaySeconds: 10
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 1
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /health
              port: 8080
              scheme: HTTP
            initialDelaySeconds: 10
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 1
      restartPolicy: Always
---
apiVersion: v1
kind: Service
metadata: {{ include "cgas.common.metadata" . | nindent 2 }}
spec:
  selector: {{ include "cgas.common.metadata-labels" . | nindent 4 }}
  ports:
    - name: http
      protocol: TCP
      port: 8080
      targetPort: 8080
---
{{- if .Values.ingress.enabled -}}
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata: {{ include "cgas.common.metadata" . | nindent 2 }}
  {{- with .Values.ingress.annotations }}
  annotations:
    {{- toYaml . | nindent 4 }}
  {{- end }}
spec:
{{- if .Values.ingress.tls }}
  tls:
  {{- range .Values.ingress.tls }}
    - hosts:
      {{- range .hosts }}
        - {{ . | quote }}
      {{- end }}
      secretName: {{ .secretName }}
  {{- end }}
{{- end }}
  rules:
  {{- range .Values.ingress.hosts }}
    - host: {{ . | quote }}
      http:
        paths:
          - path: /
            pathType: Prefix
            backend:
              service:
                name: ui
                port:
                  name: http
  {{- end }}
{{- end }}
{{ end }}
